/* LIST-4 : mutex.cpp */

#include <iostream>
#include <rw/thr/thrfunc.h>
#include <rw/thr/mutex.h>

using namespace std;

static void print_nth(int n,const char* msg) {
  static RWMutexLock mutex;
  while ( n-- ) {
    mutex.acquire();
    for ( const char* p = msg; *p ; ++p )
      cout << *p << flush;
    mutex.release();
  }
}

/* RWLockGuardg : */
/*
static void print_nth(int n,const char* msg) {
  static RWMutexLock mutex;
  while ( n-- ) {
    RWLockGuard<RWMutexLock> guard(mutex);
 // RWMutexLock::LockGuard guard(mutex); łOK.
    for ( const char* p = msg; *p ; ++p )
      cout << *p << flush;
  }
}
*/

void mutex_() {
  cout << "\n[Mutex]" << endl;
  RWThreadFunction thread1
    = rwMakeThreadFunction(print_nth,10,"hello, world\n");
  RWThreadFunction thread2
    = rwMakeThreadFunction(print_nth,10,"HELLO, WORLD\n");

  thread1.start();
  thread2.start();

  thread1.join();
  thread2.join();
}
