// mandelbrotDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "mandelbrot.h"
#include "mandelbrotDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMandelbrotDlg _CAO
const int CMandelbrotDlg::size_ = 200;

CMandelbrotDlg::CMandelbrotDlg(CWnd* pParent /*=NULL*/)
  : CDialog(CMandelbrotDlg::IDD, pParent), queue_(100) {
  //{{AFX_DATA_INIT(CMandelbrotDlg)
  //}}AFX_DATA_INIT
  icon_ = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

BEGIN_MESSAGE_MAP(CMandelbrotDlg, CDialog)
  //{{AFX_MSG_MAP(CMandelbrotDlg)
  ON_BN_CLICKED(IDC_START, OnStart)
  ON_WM_CLOSE()
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CMandelbrotDlg::OnInitDialog() {
  CDialog::OnInitDialog();
  SetIcon(icon_, TRUE);
  SetIcon(icon_, FALSE);
  GetDlgItem(IDC_PANE)->SetWindowPos(0,0,0,size_,size_,SWP_NOMOVE|SWP_NOZORDER);
  GetDlgItem(IDC_LOOP)->SetWindowText("100");
  return TRUE;
}

/* Xbh̐ƃX^[g:
 *  "Start"{^ꂽƂɌĂ΂
 */
void CMandelbrotDlg::OnStart() {
  // ĂXbhΎE
  killThreads();

  // Y҃Xbh̐
  CString str;
  GetDlgItem(IDC_LOOP)->GetWindowText(str);
  producer_ = 
    rwMakeThreadFunction(*this,
                         &CMandelbrotDlg::produce,
                         Complex(-2.0,-2.0),
                         Complex( 2.0, 2.0),
                         atoi(str));

  // ҃Xbh̐
  consumer_ = 
    rwMakeThreadFunction(*this,&CMandelbrotDlg::consume);

  // XbhX^[g!
  producer_.start();
  consumer_.start();
}      

/* z = z^2 + c ő loop JԂ
 */
int CMandelbrotDlg::calc(Complex c, int loop) {
  Complex z = 0;
  for ( int i = 0; i < loop; ++i ) {
    z = z*z + c;
    if ( std::norm(z) > 4.0 ) return i;
  }
  return -0;
}

/* Y҃Xbh:
 * fʏŏLcalcKpAʂ҂ֈn
 */
void CMandelbrotDlg::produce(Complex lo, Complex hi, int loops) {
  try {
    const Complex d = (hi - lo)/(Complex::value_type)size_;
    Complex::value_type ci = lo.imag();
    for ( int y = 0; y < size_; ++y, ci += d.imag() ) {
      Complex::value_type cr = lo.real();
      for ( int x = 0; x < size_; ++x, cr += d.real() ) {
        // vZʂQueueɏ
        queue_.write(MandelResult(x,y,calc(Complex(cr,ci),loops)));
        // LZ̎
        rwServiceCancellation();
        // UXbh𖾂nBꂪȂGUI݂̔ȂB
        rwYield();
      }
    }
  } catch ( RWCancellation& ) {
    // LZꂽBɉ邱Ƃ͂ȂB
  }
  // f[^̏I:҃Xbh͂󗝂_ŏI
  queue_.write(MandelResult(-1,-1,0));
}

/* ҃Xbh:
 * Y҃Xbh󂯎ʂ`悷
 */
void CMandelbrotDlg::consume() {
  // Fe[u
  static COLORREF table[] = {
    RGB(  0,  0,  0), RGB(  0,  0,255), RGB(  0,255,  0), RGB(  0,255,255),
    RGB(255,  0,  0), RGB(255,  0,255), RGB(255,255,  0), RGB(255,255,255),
  };
  // foCXReLXg擾
  CDC* dc = GetDlgItem(IDC_PANE)->GetDC();
  // NA
  dc->FillSolidRect(0,0,size_,size_,RGB(255,255,255));
  // Queuef[^oA`悷
  MandelResult mr;
  while ( (mr = queue_.read()).valid() ) {
    dc->SetPixel(mr.x, size_-1-mr.y, table[mr.c&7]);
  }
  // foCXReLXg
  GetDlgItem(IDC_PANE)->ReleaseDC(dc);
}

/* Xbh̒~:
 */
void CMandelbrotDlg::killThreads() {
  // Y҃XbhɃLZv
  try {
    producer_.requestCancellation();
  } catch ( RWTHRInvalidPointer& ) {
    // ŏɌĂ΂ꂽƂAXbhĂȂ̂
    // OBč\ȂB
  }
}

void CMandelbrotDlg::OnClose() {
  killThreads();	
  CDialog::OnClose();
}

