// mandelbrotDlg.h : wb_[ t@C
//

#if !defined(AFX_MANDELBROTDLG_H__BA43D776_1BA8_11D2_8DFE_00A0C90AA4BD__INCLUDED_)
#define AFX_MANDELBROTDLG_H__BA43D776_1BA8_11D2_8DFE_00A0C90AA4BD__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CMandelbrotDlg dialog

class CMandelbrotDlg : public CDialog {

  typedef std::complex<float> Complex;
  struct MandelResult {
    int x, y, c;
    MandelResult(int xx,int yy, int cc) : x(xx), y(yy), c(cc) {}
    MandelResult() {}
    bool valid() const { return x >= 0; }
  };

  RWPCValQueue<MandelResult> queue_;
  RWThreadFunction           producer_;
  RWThreadFunction           consumer_;
  static const int           size_;
  HICON                      icon_;

  static int calc(Complex,int);
  void       produce(Complex lo, Complex hi, int loops);
  void       consume();
  void       killThreads();

public:
  CMandelbrotDlg(CWnd* pParent = NULL);

  //{{AFX_DATA(CMandelbrotDlg)
  enum { IDD = IDD_MANDELBROT_DIALOG };
  //}}AFX_DATA

  //{{AFX_VIRTUAL(CMandelbrotDlg)
  //}}AFX_VIRTUAL

protected:

  //{{AFX_MSG(CMandelbrotDlg)
  virtual BOOL OnInitDialog();
  afx_msg void OnStart();
  afx_msg void OnClose();
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_MANDELBROTDLG_H__BA43D776_1BA8_11D2_8DFE_00A0C90AA4BD__INCLUDED_)
